package Pair;

/**
 * You need to store two values of type `E`, set them in a constructor, and have the following methods,
 * getFirst
 * getSecond
 * min -> returns the minimum of the pair
 * max -> returns the maximum of the pair
 */
public class Pair<E extends Comparable> {
    private E first;
    private E second;

    public Pair(E e1, E e2){
        this.first = e1;
        this.second = e2;
    }

    public E getFirst() {
        return first;
    }

    public void setFirst(E first) {
        this.first = first;
    }

    public E getSecond() {
        return second;
    }

    public void setSecond(E second) {
        this.second = second;
    }

    public <E> E min(){
        first = getFirst();
        second = getSecond();

        if(first.compareTo(second) < second.compareTo(first)){
            return (E) first;
        } else return (E) second;
    }

    public <E> E max(){
        first = getFirst();
        second = getSecond();

        if(first.compareTo(second) > second.compareTo(first)){
            return (E) first;
        } else return (E) second;
    }
}
