package StackArray;

import java.lang.reflect.Array;
import java.util.Arrays;


/**
 * Expand the ArrayList implementation of stack here to use an E[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class GenericStack<E> {

    private E elements[];
    private int top;

    public GenericStack(){
        elements = (E[]) new Object[1];
        this.top = 0;
    }


    public void push(E e){
        if(top < elements.length - 1){
            elements[top++] = e;
        }else{
            E newElements[] = Arrays.copyOf(elements, elements.length+1);
            newElements[top++] = e;
            elements = newElements;
        }
    }

    public E pop(){

        E popped = elements[--top];
        return popped;
    }

    public boolean isEmpty(){

        return (top == 0);
    }
}
