package StackArray;

import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an Object[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class ObjectStack<E> {
    private  Object[] elements;
    private int top;

    public ObjectStack(){
        elements = new Object[1];
        this.top = 0;
    }


    public void push(E e){
        if(top < elements.length - 1){
            elements[top++] = e;
        }else{
             Object[] newElements = Arrays.copyOf(elements, elements.length+1);
            newElements[top++] = e;
            elements = newElements;
        }
    }

    public Object pop(){

        Object popped = elements[--top];
        return popped;
    }

    public boolean isEmpty(){

        return (top == 0);
    }
}
